=== debian/changelog ===
hypre (2.14.0-5build1) disco; urgency=medium

  * No-change rebuild against libsuperlu-dist6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 14 Nov 2018 23:09:24 +0000

hypre (2.14.0-5) unstable; urgency=medium

  * Team upload.
  * remove patchelf from Build-Depends. Its usage in
    shlibs-interlink-sublibs.patch is currently disabled anyway, and
    it is not available on mips,mipsel.

 -- Drew Parsons <dparsons@debian.org>  Tue, 06 Nov 2018 14:44:35 +0800

hypre (2.14.0-4) unstable; urgency=medium

  * Team upload.
  * add missing library links for libHYPRE_mli.so and
    libHYPRE_parcsr_mv.so to superlu (patch superlu_libs.patch)
    - Bug#902102: patchelf is currently broken (bug#903396) and can't
      be used to resolve circular dependencies. Instead manually invoke
      "-lHYPRE_FEI -lHYPRE_mli -lHYPRE_FEI" or
      "-lHYPRE_parcsr_mv -lHYPRE_parcsr_ls -lHYPRE_parcsr_mv" if needed.

 -- Drew Parsons <dparsons@debian.org>  Fri, 28 Sep 2018 02:44:37 +0800

hypre (2.14.0-3) unstable; urgency=medium

  * Team upload.
  * Update debian/watch to hypre github repository. Upstream have been
    shy about announcing their latest versions on their website.
  * run tests at build time
  * add debian/tests (autopkgtest)
  * Standards-Version: 4.2.1

 -- Drew Parsons <dparsons@debian.org>  Wed, 26 Sep 2018 18:09:26 +0800

hypre (2.14.0-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.1.4

 -- Drew Parsons <dparsons@debian.org>  Sun, 08 Apr 2018 12:16:15 +0800

hypre (2.14.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 2.14.0
    - new AIR AMG solver
    - refresh debian patches, add superlu_libs.patch to link against
      libsuper_dist.so
  * d/rules: read upstream version from debian/changelog
  * Standards-Version: 4.1.3
  * debhelper compatibility level 11
  * update VCS tags to salsa.debian.org

 -- Drew Parsons <dparsons@debian.org>  Tue, 27 Mar 2018 14:05:07 +0800
