=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hypre-$1.tar.gz%" \
  https://github.com/LLNL/hypre/releases \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
